Index: trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp	(revision 485)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RssTree.cpp	(revision 492)
@@ -1789,6 +1782,214 @@
   if (r1 == r2)
 	r2 = (r1+1)%leaf->rays.size();
-}
-
+
+#else
+  // pick a random ray
+  int base = Random(nrays);
+  RssTreeNode::RayInfo *baseRay = &leaf->rays[base];
+  Intersectable *baseObject = baseRay->GetObject();
+  
+  // and a random 5D derivative which will be used to find the minimal projected distances
+  Vector3 spatialDerivative;
+  Vector3 directionalDerivative;
+
+  while (1) {
+	spatialDerivative = Vector3(RandomValue(-1.0f, 1.0f),
+								RandomValue(-1.0f, 1.0f),
+								RandomValue(-1.0f, 1.0f));
+	float m = Magnitude(spatialDerivative);
+	if (m != 0) {
+	  spatialDerivative /= m*Magnitude(GetBBox(leaf).Size());
+	  break;
+	}
+  }
+
+  while (1) {
+	directionalDerivative = Vector3(RandomValue(-1.0f, 1.0f),
+									RandomValue(-1.0f, 1.0f),
+									0.0f);
+	float m = Magnitude(directionalDerivative);
+	if (m != 0) {
+	  directionalDerivative /= m*Magnitude(GetDirBBox(leaf).Size());
+	  break;
+	}
+  }
+
+  // now find the furthest sample from the same object and the closest from a different object
+  int i = 0;
+  float minDist = MAX_FLOAT;
+  float maxDist = -MAX_FLOAT;
+  r1 = base;
+  r2 = base;
+  for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++, i++) {
+	float dist = RssTreeNode::RayInfo::SqrDistance5D(*baseRay,
+													 *ri,
+													 spatialDerivative,
+													 directionalDerivative
+													 );
+
+	if ((*ri).GetObject() == baseObject) {
+	  if (dist > maxDist) {
+		maxDist = dist;
+		r1 = i;
+	  }
+	} else {
+	  if (dist > 0.0f && dist < minDist) {
+		minDist = dist;
+		r2 = i;
+	  }
+	}
+  }
+  
+#endif
+}
+
+
+struct RayNeighbor {
+  int rayInfo;
+  float distance;
+  RayNeighbor():rayInfo(0), distance(MAX_FLOAT) {}
+};
+
+void
+RssTree::FindSilhouetteRays(RssTreeLeaf *leaf,
+							vector<RssTreeLeaf::SilhouetteRays> &rays
+							)
+{
+  // for every leaf find its neares neighbor from a different object
+  vector<RayNeighbor> neighbors(leaf->rays.size());
+  int i, j;
+  for (i=0; i < leaf->rays.size(); i++)
+	for (j=0; j < leaf->rays.size(); j++)
+	  if (i!=j) {
+		float d = RssTreeLeaf::RayInfo::Distance(leaf->rays[i], leaf->rays[j]);
+		if (d < neighbors[i].distance) {
+		  neighbors[i].distance = d;
+		  neighbors[i].rayInfo = j;
+		}
+	  }
+
+  // now check which are the pairs of nearest neighbors
+  for (i=0; i < leaf->rays.size(); i++) {
+	int j = neighbors[i].rayInfo;
+	if (neighbors[j].rayInfo == i) {
+	  // this is a silhouette edge pair
+	  if (i < j) {
+		// generate an silhoutte ray pair
+		rays.push_back(RssTreeLeaf::SilhouetteRays(&leaf->rays[i],
+												   &leaf->rays[j]));
+	  }
+	} else {
+	  // this is not a silhouette ray - delete???
+	}
+  }
+  
+}
+
+
+bool
+GetRandomTripple(vector<RssTreeLeaf::RayInfo *> &rays,
+				 const int index,
+				 int &i1,
+				 int &i2,
+				 int &i3)
+{
+  int found = 0;
+  int indices[3];
+
+  int size = rays.size();
+  // use russian roulete selection for the tripple
+  // number of free positions for the bullet
+  int positions = size - 1;
+  int i;
+  for (i=0; i < size; i++) {
+	if (rays[i]->mRay->Mailed())
+	  positions--;
+  }
+  
+  if (positions < 3)
+	return false;
+  
+  for (i=0; i < size; i++) {
+	if (i != index && !rays[i]->mRay->Mailed()) {
+	  float p = (3 - found)/(float)positions;
+	  if (Random(1.0f) < p) {
+		indices[found] = i;
+		found++;
+	  }
+	}
+	positions--;
+  }
+}
+
+bool
+RssTree::IsRayConvexCombination(const RssTreeNode::RayInfo &ray,
+								const RssTreeNode::RayInfo &r1,
+								const RssTreeNode::RayInfo &r2,
+								const RssTreeNode::RayInfo &r3)
+{
+  
+
+  return false;
+}
+
+int
+RssTree::RemoveInteriorRays(
+							RssTreeLeaf *leaf
+							)
+{
+#if 1
+  // first collect all objects refered in this leaf
+  map<Intersectable *, vector<RssTreeLeaf::RayInfo *> > rayMap;
+  
+  RssTreeLeaf::RayInfoContainer::iterator it = leaf->rays.begin();
+  for (; it != leaf->rays.end(); ++it) {
+	Intersectable *object = (*it).GetObject();
+	
+	rayMap[object].push_back(&(*it));
+// 	vector<RayInfo *> *data = rayMap.Find(object);
+// 	if (data) {
+// 	  data->push_back(&(*it));
+// 	} else {
+// 	  //	  rayMap[object] = vector<RayInfo *>;
+// 	  rayMap[object].push_back(&(*it));
+// 	}
+  }
+
+  // now go through all objects
+  map<Intersectable *, vector<RssTreeLeaf::RayInfo *> >::iterator mi;
+
+  // infos of mailed rays are scheduled for removal
+  VssRay::NewMail();
+  for (mi = rayMap.begin(); mi != rayMap.end(); ++ mi) {
+	vector<RssTreeLeaf::RayInfo *> &rays = (*mi).second;
+	vector<RssTreeLeaf::RayInfo *>::iterator ri = rays.begin();
+	int rayIndex = 0;
+	
+	for (; ri != rays.end(); ++ri, ++rayIndex) {
+	  RssTreeNode::RayInfo *ray = *ri;
+	  int tries = rays.size();
+	  for (int i = 0; i < tries; i++) {
+		int r1, r2, r3;
+		GetRandomTripple(rays,
+						 rayIndex,
+						 r1,
+						 r2,
+						 r3);
+		if (IsRayConvexCombination(*ray,
+								   *rays[r1],
+								   *rays[r2],
+								   *rays[r3])) {
+		  ray->mRay->Mail();
+		}
+	  }
+	}
+  }
+  
+
+#endif  
+	return 0;
+}
 
 void
@@ -1798,36 +1999,359 @@
 {
 
+  if (numberOfRays == 0)
+	return;
+  
   int nrays = leaf->rays.size();
-  for (int i=0; i < numberOfRays; i++) {
-	bool useExtendedConvexCombination = (nrays >= 2) && (i > numberOfRays/2);
-
-		
+
+
+  AxisAlignedBox3 box = GetBBox(leaf);
+  AxisAlignedBox3 dirBox = GetDirBBox(leaf);
+
+  AxisAlignedBox3 sBox(box);
+  AxisAlignedBox3 sDirBox(dirBox);
+  const float smoothRange = 0.5f;
+  sBox.Scale(1.0f + smoothRange);
+  sDirBox.Scale(1.0f + smoothRange);
+  int smoothRays = (int)numberOfRays*0.0f;
+  
+#if AVG_LEN
+  float avgLength = 0.0f;
+
+  if (nrays) {
+	const int numAvg = 5;
+	
+	int step = (nrays-1)/10;
+	if (step<1)
+	  step = 1;
+	
+	int summed = 0;
+	float sumLength = 0.0f;
+	for (int i=0; i < nrays; i+=step) {
+	  sumLength += leaf->rays[i].mRay->GetSize();
+	  summed++;
+	}
+  
+	avgLength = sumLength/summed;
+  }
+#endif
+  
+  Exporter *exporter = NULL;
+  VssRayContainer selectedRays;
+  static int counter = 0;
+  if (counter < 0) {
+	char filename[128];
+	sprintf(filename, "selected-rays%04d.x3d", counter);
+	exporter = Exporter::GetExporter(filename);
+	//	exporter->SetWireframe();
+	//	exporter->ExportKdTree(*mKdTree);
+	exporter->SetWireframe();
+	exporter->ExportScene(preprocessor->mSceneGraph->mRoot);
+	exporter->SetWireframe();
+	exporter->ExportBox(box);
+	exporter->SetFilled();
+	counter++;
+  }
+  
+  int numberOfTries = numberOfRays*4;
+  int generated = 0;
+
+  Intersectable::NewMail();
+  vector<Intersectable *> pvs(0);
+  pvs.reserve(leaf->GetPvsSize());
+  for(RssTreeNode::RayInfoContainer::iterator ri = leaf->rays.begin();
+	  ri != leaf->rays.end();
+	  ri++) {
+	Intersectable *object = (*ri).GetObject();
+	if (object && !object->Mailed()) {
+	  object->Mail();
+	  pvs.push_back(object);
+	  if (exporter)
+		exporter->ExportIntersectable(object);
+	}
+  }
+  
+  for (int i=0; generated < numberOfRays && i < numberOfTries; i++) {
+	bool useExtendedConvexCombination = ((nrays >= 2) && (Random(1.0f) < 0.7f));
+	
 	Vector3 origin, direction;
 	// generate half of convex combination and half of random rays
 	if (useExtendedConvexCombination) {
-	  // pickup 3 random rays
+	  // pickup 2 random rays
 	  int r1, r2;
 	  PickEdgeRays(leaf, r1, r2);
+
 	  
 	  Vector3 o1 = leaf->rays[r1].GetOrigin();
 	  Vector3 o2 = leaf->rays[r2].GetOrigin();
 	  
-	  const float overlap = 0.1f;
+	  const float overlap = 0.0f;
 	  float w1, w2;
 	  GenerateExtendedConvexCombinationWeights2(w1, w2, overlap);
 	  origin = w1*o1 + w2*o2;
+	  GenerateExtendedConvexCombinationWeights2(w1, w2, overlap);
 	  direction =
-		w1*leaf->rays[r1].mRay->GetDir() +
-		w2*leaf->rays[r2].mRay->GetDir();
-	  // shift the origin a little bit
-	  origin += direction*0.1f;
+		w1*leaf->rays[r1].GetDir() +
+		w2*leaf->rays[r2].GetDir();
 	} else {
-	  origin = GetBBox(leaf).GetRandomPoint();
-	  Vector3 dirVector = GetDirBBox(leaf).GetRandomPoint();
+	  Vector3 dirVector;
+
+	  Vector3 pVector;
+	  Vector3 dVector;
+
+	  bool useHalton = true;
+	  
+	  if (useHalton) {
+		// generate a random 5D vector
+		pVector = Vector3(leaf->halton.GetNumber(1),
+						  leaf->halton.GetNumber(2),
+						  leaf->halton.GetNumber(3));
+		
+		dVector = Vector3(leaf->halton.GetNumber(4),
+						  leaf->halton.GetNumber(5),
+						  0.0f);
+		leaf->halton.GenerateNext();
+	  } else {
+		pVector = Vector3(RandomValue(0.0f, 1.0f),
+						  RandomValue(0.0f, 1.0f),
+						  RandomValue(0.0f, 1.0f));
+		
+		dVector = Vector3(RandomValue(0.0f, 1.0f),
+						  RandomValue(0.0f, 1.0f),
+						  0.0f);
+	  }
+	  
+	  if (i < smoothRays) {
+		origin = sBox.GetPoint(pVector);
+		dirVector = sDirBox.GetPoint(dVector);
+	  } else {
+		origin = box.GetPoint(pVector);
+		dirVector = dirBox.GetPoint(dVector);
+	  }
 	  direction = Vector3(sin(dirVector.x), sin(dirVector.y), cos(dirVector.x));
 	}
-	//cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
-	rays.push_back(SimpleRay(origin, direction));
-  }
+
+	// shift the origin a little bit
+	direction.Normalize();
+	
+	//	float dist = Min(avgLength*0.5f, Magnitude(GetBBox(leaf).Size()));
+	float dist = 0.0f;
+	float minT, maxT;
+	// compute interection of the ray with the box
+
+	if (box.ComputeMinMaxT(origin, direction, &minT, &maxT) && minT < maxT)
+	  dist = maxT;
+  
+	
+	origin += direction*dist;
+	
+	bool intersects = false;
+	
+
+	if (i > numberOfRays/2) {
+	  if (exporter) {
+		VssRay *ray = new VssRay(origin, origin + 100*direction, NULL, NULL);
+		selectedRays.push_back(ray);
+	  }
+
+	  // check whether the ray does not intersect already visible objects
+	  Ray traversalRay;
+	  traversalRay.Init(origin, direction, Ray::LOCAL_RAY);
+	  for(vector<Intersectable *>::const_iterator oi = pvs.begin();
+		  oi != pvs.end();
+		  oi++) {
+		Intersectable *object = *oi;
+		
+		if ( object->CastRay(traversalRay) ) {
+		  intersects = true;
+		  break;
+		}
+	  }
+	}
+	
+	
+	if (!intersects) {
+	  //cout<<"dir vector.x="<<dirVector.x<<"direction'.x="<<atan2(direction.x, direction.y)<<endl;
+	  rays.push_back(SimpleRay(origin, direction));
+	  generated++;
+	}
+  }
+
+  //  cout<<"desired="<<numberOfRays<<" tries="<<i<<endl;
+  
+  if (exporter) {
+	exporter->ExportRays(selectedRays, RgbColor(1, 0, 0));
+	delete exporter;
+	CLEAR_CONTAINER(selectedRays);
+  }
+}
+
+int
+RssTree::PruneRays(RssTreeLeaf *leaf,
+				   const float contributionThreshold)
+{
+  int i;
+  int j;
+  
+  for (j=0, i=0; i < leaf->rays.size(); i++) {
+	
+	if (leaf->rays[i].mRay->mWeightedPvsContribution > contributionThreshold) {
+	  // copy a valid sample
+	  if (i!=j) 
+		leaf->rays[j] = leaf->rays[i];
+	  j++;
+	} else {
+	  // delete the ray
+	  leaf->rays[i].mRay->Unref();
+	  if (leaf->rays[i].mRay->RefCount() != 0) {
+		cerr<<"Error: refcount!=0, but"<<leaf->rays[j].mRay->RefCount()<<endl;
+		exit(1);
+	  }
+	  delete leaf->rays[i].mRay;
+	}
+  }
+
+
+  leaf->rays.resize(j);
+  int removed = (i-j);
+  stat.rayRefs -= removed;
+  return removed;
+}
+
+int
+RssTree::PruneRaysRandom(RssTreeLeaf *leaf,
+						 const float ratio)
+{
+  int i;
+  int j;
+  
+  for (j=0, i=0; i < leaf->rays.size(); i++) {
+	
+	if (Random(1.0f) < ratio) {
+	  // copy a valid sample
+	  if (i!=j) 
+		leaf->rays[j] = leaf->rays[i];
+	  j++;
+	} else {
+	  // delete the ray
+	  leaf->rays[i].mRay->Unref();
+	  if (leaf->rays[i].mRay->RefCount() != 0) {
+		cerr<<"Error: refcount!=0, but"<<leaf->rays[j].mRay->RefCount()<<endl;
+		exit(1);
+	  }
+	  delete leaf->rays[i].mRay;
+	}
+  }
+
+
+  leaf->rays.resize(j);
+  int removed = (i-j);
+  stat.rayRefs -= removed;
+  return removed;
+}
+
+int
+RssTree::PruneRaysContribution(RssTreeLeaf *leaf,
+							   const float ratio)
+{
+  int i;
+  
+  if (leaf->rays.size() == 0)
+	return 0;
+  
+  sort(leaf->rays.begin(),
+	   leaf->rays.end(),
+	   RssTreeLeaf::RayInfo::GreaterWeightedPvsContribution);
+
+  int desired = ratio*leaf->rays.size();
+  int removed = leaf->rays.size() - desired;
+  
+  for (i=desired; i < leaf->rays.size(); i++) {
+	// delete the ray
+	leaf->rays[i].mRay->Unref();
+	if (leaf->rays[i].mRay->RefCount() != 0) {
+	  cerr<<"Error: refcount!=0, but"<<leaf->rays[i].mRay->RefCount()<<endl;
+	  exit(1);
+	}
+	delete leaf->rays[i].mRay;
+  }
+  
+  leaf->rays.resize(desired);
+  stat.rayRefs -= removed;
+  return removed;
+}
+
+
+int
+RssTree::PruneRays(
+				   const int desired
+				   )
+{
+  bool globalPrunning = false;
+
+  stack<RssTreeNode *> tstack;
+  int prunned = 0;
+
+  Debug<<"Prunning rays...\nOriginal size "<<stat.rayRefs<<endl;
+
+  if (globalPrunning) {
+	VssRayContainer allRays;
+	allRays.reserve(stat.rayRefs);
+	CollectRays(allRays);
+	sort(allRays.begin(),
+		 allRays.end(),
+		 GreaterWeightedPvsContribution);
+	
+	if ( desired >= allRays.size() )
+	  return 0;
+	
+	float contributionThreshold = allRays[desired]->mWeightedPvsContribution;
+	
+	tstack.push(root);
+	
+	while (!tstack.empty()) {
+	  RssTreeNode *node = tstack.top();
+	  tstack.pop();
+	  
+	  if (node->IsLeaf()) {
+		RssTreeLeaf *leaf = (RssTreeLeaf *)node;
+		prunned += PruneRays(leaf, contributionThreshold);
+	  } else {
+		RssTreeInterior *in = (RssTreeInterior *)node;
+		// both nodes for directional splits
+		tstack.push(in->front);
+		tstack.push(in->back);
+	  }
+	}
+  } else {
+	// prune random rays from each leaf so that the ratio's remain the same
+	tstack.push(root);
+	float ratio = desired/(float)stat.rayRefs;
+	
+	while (!tstack.empty()) {
+	  RssTreeNode *node = tstack.top();
+	  tstack.pop();
+	  
+	  if (node->IsLeaf()) {
+		RssTreeLeaf *leaf = (RssTreeLeaf *)node;
+		//		prunned += PruneRaysRandom(leaf, ratio);
+		prunned += PruneRaysContribution(leaf, ratio);
+	  } else {
+		RssTreeInterior *in = (RssTreeInterior *)node;
+		// both nodes for directional splits
+		tstack.push(in->front);
+		tstack.push(in->back);
+	  }
+	}
+
+	
+
+
+  }
+  
+  
+  
+  Debug<<"Remained "<<stat.rayRefs<<" rays"<<endl;
+  
+  return prunned;
 }
 
@@ -1837,4 +2361,5 @@
 					  SimpleRayContainer &rays)
 {
+
 
   vector<RssTreeLeaf *> leaves;
@@ -1859,5 +2384,11 @@
 				
   float avgContrib = sumContrib/numberOfLeaves;
-  float ratioPerLeaf = numberOfRays/(avgContrib*numberOfLeaves);
+  
+  // always generate at leat n ray per leaf
+  int fixedPerLeaf = 1;
+  int fixed = 1*leaves.size();
+  int iGenerated = numberOfRays;
+  float ratioPerLeaf = iGenerated /(avgContrib*numberOfLeaves);
+
   k = 0;
   for (i=0; i < leaves.size() && k < numberOfLeaves; i++)
@@ -1866,5 +2397,6 @@
 	  RssTreeLeaf *leaf = leaves[i];
 	  float c = leaf->GetImportance();
-	  int num = (c*ratioPerLeaf + 0.5);
+
+	  int num = fixedPerLeaf + (int)(c*ratioPerLeaf + 0.5f);
 	  GenerateLeafRays(leaf, num, rays);
 	}
@@ -1889,5 +2421,5 @@
 	  RssTreeLeaf *leaf = (RssTreeLeaf *)node;
 	  // update pvs size
-	  leaf->UpdatePvsSize();
+	  UpdatePvsSize(leaf);
 	  sumPvs += leaf->GetPvsSize();
 	  leaves++;
@@ -1904,31 +2436,114 @@
 }
 
-	
+float weightAbsContributions = 0.0f;
+// if small very high importance of the last sample
+// if 1.0f then weighs = 1 1/2 1/3 1/4
+float passSampleWeightDecay = 0.5f;
+
+void
+RssTree::GetRayContribution(const RssTreeNode::RayInfo &info,
+							float &weight,
+							float &contribution)
+{
+  VssRay *ray = info.mRay;
+  weight = 1.0f/(mCurrentPass - ray->mPass + passSampleWeightDecay);
+  contribution =
+	weightAbsContributions*ray->mPvsContribution +
+	(1.0f - weightAbsContributions)*ray->mRelativePvsContribution;
+  // store the computed value
+  info.mRay->mWeightedPvsContribution = weight*contribution;
+}
+
+float
+RssTree::GetSampleWeight(const int pass)
+{
+  int passDiff = mCurrentPass - pass;
+  float weight;
+  if (1) 
+	weight = 1.0f/(passDiff + passSampleWeightDecay);
+  else 
+	switch (passDiff) {
+	case 0:
+	  weight = 1.0f;
+	  break;
+	default:
+	  weight = 0.01f;
+	  break;
+	  // 	case 1:
+// 	  weight = 0.5f;
+// 	  break;
+// 	case 2:
+// 	  weight = 0.25f;
+// 	  break;
+// 	case 3:
+// 	  weight = 0.12f;
+// 	  break;
+// 	case 4:
+// 	  weight = 0.06f;
+// 	  break;
+// 	default:
+// 	  weight = 0.03f;
+// 	  break;
+	}
+  return weight;
+}
+
+void
+RssTree::ComputeImportance(RssTreeLeaf *leaf) 
+{
+  if (0) 
+	leaf->mImportance = leaf->GetAvgRayContribution();
+  else {
+	RssTreeNode::RayInfoContainer::const_iterator it = leaf->rays.begin(),
+	  it_end = leaf->rays.end();
+	
+	float sumContributions = 0.0f;
+	float sumRelContributions = 0.0f;
+	float sumWeights = 0.0f;
+	for (; it != it_end; ++it) {
+	  VssRay *ray = (*it).mRay;
+	  float weight = GetSampleWeight(ray->mPass);
+	  
+	  sumContributions += weight*ray->mPvsContribution;
+	  sumRelContributions += weight*ray->mRelativePvsContribution;
+	  
+	  //	  sumWeights += weight;
+	  sumWeights += 1.0f;
+	}
+	// $$ 
+	// sumWeights = leaf->mTotalRays;
+	  
+	if (sumWeights != 0.0f) 
+	  leaf->mImportance =
+		(weightAbsContributions*sumContributions +
+		 (1.0f - weightAbsContributions)*sumRelContributions)/sumWeights;
+	else
+	  leaf->mImportance = 0.0f;
+	
+  }
+  
+  // return GetAvgRayContribution()*mImportance;
+  //return GetAvgRayContribution();
+}
+
+
 float
 RssTreeLeaf::GetImportance()  const
 {
-
-  if (1) {
-	return GetAvgRayContribution();
-	//	return GetPvsSize();
-  } else {
-	// return GetAvgRayContribution()*mEntropyImportance;
-	//return GetAvgRayContribution();
-	return mEntropyImportance;
-  }
+  return mImportance;
 }
 
 
 float
-RssTreeLeaf::ComputePvsEntropy()
+RssTreeLeaf::ComputePvsEntropy() const
 {
   int samples = 0;
   Intersectable::NewMail();
   // set all object as belonging to the fron pvs
-  for(RssTreeNode::RayInfoContainer::iterator ri = rays.begin();
+  for(RssTreeNode::RayInfoContainer::const_iterator ri = rays.begin();
 	  ri != rays.end();
 	  ri++)
 	if ((*ri).mRay->IsActive()) {
-	  Intersectable *object = (*ri).mRay->mTerminationObject;
+	  Intersectable *object = (*ri).GetObject();
 	  if (object) {
 		if (!object->Mailed()) {
@@ -1949,5 +2564,5 @@
 		ri++) 
 	  if ((*ri).mRay->IsActive()) {
-		Intersectable *object = (*ri).mRay->mTerminationObject;
+		Intersectable *object = (*ri).GetObject();
 		if (object) {
 		  if (!object->Mailed()) {
@@ -1967,5 +2582,5 @@
 
 float
-RssTreeLeaf::ComputeRayLengthEntropy()
+RssTreeLeaf::ComputeRayLengthEntropy() const
 {
   // get sum of all ray lengths
@@ -2017,14 +2632,20 @@
 
 
-void
-RssTreeLeaf::ComputeEntropyImportance()
-{
-  mPvsEntropy = ComputePvsEntropy();
-  mRayLengthEntropy = ComputeRayLengthEntropy();
+float
+RssTreeLeaf::ComputeEntropyImportance() const
+{
   
   //  mEntropy = 1.0f - ComputeRayLengthEntropy();
-  mEntropyImportance = 1.0f - ComputePvsEntropy();
-  
-  //  cout<<"ei="<<mEntropyImportance<<" ";
+  return 1.0f - ComputePvsEntropy();
+}
+
+float
+RssTreeLeaf::ComputeRayContributionImportance() const
+{
+  //  mPvsEntropy = ComputePvsEntropy();
+  //  mRayLengthEntropy = ComputeRayLengthEntropy();
+  
+  //  mEntropy = 1.0f - ComputeRayLengthEntropy();
+  return 1.0f - ComputePvsEntropy();
 }
 
@@ -2059,4 +2680,5 @@
   VssRayContainer allRays;
   CollectRays(allRays);
+
   
   int desired = min(number, (int)allRays.size());
@@ -2105,2 +2727,3 @@
   return (int)rays.size();
 }
+
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 467)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.h	(revision 492)
@@ -6,4 +6,5 @@
 #include "Vector3.h"
 #include "Ray.h"
+#include "Containers.h"
 
 class AxisAlignedBox3;
@@ -45,4 +46,6 @@
   Intersectable *mTerminationObject;
 
+  ViewCellContainer mViewCells;
+  
   ////////////////////////
   // members related to importance sampling
@@ -55,4 +58,9 @@
   // sum of relative ray contributions per object
   float mRelativePvsContribution;
+
+
+  // weighted contribution to the pvs (based on the pass the ray was casted at)
+  // computed by the prperocessor
+  float mWeightedPvsContribution;
   
   //////////////////////////////
@@ -71,5 +79,7 @@
 	mRefCount(0),
     mFlags(0),
-	mPass(pass)
+	mPass(pass),
+	mViewCells(0),
+	mWeightedPvsContribution(0)
 	//	mT(1.0f)
   {
@@ -82,27 +92,28 @@
 	mMailbox(-1),
 	mOriginObject(ray.sourceObject.mObject),
-	mPass(0)
+	mPass(0),
+	mViewCells(0)
 	//	mT(1.0f)
-	{
-		if (ray.sourceObject.mObject)
-			mOrigin = ray.Extrap(ray.sourceObject.mT);
-		else
-			mOrigin = ray.GetLoc(); 
-
-		//Debug << "origin: " << mOrigin << endl;
-		if (!ray.intersections.empty())
-		{
-			mTermination = ray.Extrap(ray.intersections[0].mT);
-			mTerminationObject = ray.intersections[0].mObject;
-		}
-		else
-		{
-			mTermination = ray.Extrap(1e6);//TODO: should be Limits::Infinity
-			mTerminationObject = NULL;
-		}
-
-		Precompute();
-  }
-
+  {
+	if (ray.sourceObject.mObject)
+	  mOrigin = ray.Extrap(ray.sourceObject.mT);
+	else
+	  mOrigin = ray.GetLoc(); 
+	
+	//Debug << "origin: " << mOrigin << endl;
+	if (!ray.intersections.empty())
+	  {
+		mTermination = ray.Extrap(ray.intersections[0].mT);
+		mTerminationObject = ray.intersections[0].mObject;
+	  }
+	else
+	  {
+		mTermination = ray.Extrap(1e6);//TODO: should be Limits::Infinity
+		mTerminationObject = NULL;
+	  }
+	
+	Precompute();
+  }
+  
   void Precompute() {
     mFlags = 0;
@@ -158,4 +169,5 @@
 	
   float GetDirParametrization(const int axis) const;
+  float GetOpositeDirParametrization(const int axis) const;
 
   static float VssRay::GetDirParam(const int axis, const Vector3 dir);
@@ -230,4 +242,26 @@
   }
 
+  friend bool GreaterWeightedPvsContribution(const VssRay * a,
+											 const VssRay *b) {
+	return a->mWeightedPvsContribution > b->mWeightedPvsContribution;
+  }
+
+  float SqrDistance(const Vector3 &point) const {
+	Vector3 diff = point - mOrigin;
+	float t = DotProd(diff, GetDir());
+	
+    if ( t <= 0.0f ) {
+	  t = 0.0f;
+    } else {
+	  if (t >= 1.0f) {
+		t = 1.0f;
+	  } else {
+        t /= SqrMagnitude(GetDir());
+	  }
+	  diff -= t*GetDir();
+	}
+    return SqrMagnitude(diff);
+  }
+
 };
 
@@ -272,4 +306,10 @@
 {
   void PrintStatistics(ostream &s);
+  int SelectRays(const int number, VssRayContainer &selected) const;
+  int
+  GetContributingRays(VssRayContainer &selected,
+					  const int minPass
+					  ) const;
+  
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Environment.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Environment.h	(revision 372)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Environment.h	(revision 492)
@@ -206,6 +206,6 @@
    */
   bool CheckForSwitch(const int argc,
-		      const char *argv[],
-		      const char swtch) const;
+					  char **argv,
+					  const char swtch) const;
   /** First pass of parsing command line.
     This function parses command line and gets from there all non-optional
@@ -220,6 +220,6 @@
    */
   void ReadCmdlineParams(const int argc,
-			 const char *argv[],
-			 const char *optParams);
+						 char **argv,
+						 const char *optParams);
   /** Reading of the environment file.
     This function reads the environment file.
@@ -236,5 +236,5 @@
                  be read in.
    */
-  void ParseCmdline(const int argc, const char *argv[], const int index);
+  void ParseCmdline(const int argc, char **argv, const int index);
 
   /** Clears the environment data structures.
@@ -335,5 +335,5 @@
   //@}
 
-  void Parse(const int argc, const char *argv[], bool useExePath);
+  void Parse(const int argc, char **argv, bool useExePath);
 
   void
